
#include <sys/param.h>
#include <sys/types.h>
#include <sys/module.h>
#include <sys/kernel.h>
#include <sys/systm.h>
#include <sys/malloc.h>
#include <sys/sysctl.h>

extern int caml_startup(char**);

MALLOC_DEFINE(M_CAML, "caml", "Caml run-time");

static SYSCTL_NODE(_kern, OID_AUTO, caml, CTLFLAG_RD, NULL, "caml");

char *exe_name = "kmod";

static int
sysctl_kern_caml_run(SYSCTL_HANDLER_ARGS)
{
	int error, i;

	error = sysctl_wire_old_buffer(req, sizeof(int));
	if (error == 0) {
		i = 0;
		error = sysctl_handle_int(oidp, &i, 0, req);
	}
	if (error != 0 || req->newptr == NULL)
		return (error);
	{
		char *argv[2];
		uprintf("[CAML] Calling Caml code...\n");
		argv[0] = exe_name;
		argv[1] = NULL;
		caml_startup(argv);
	}
	return (0);
}

SYSCTL_PROC(_kern_caml, OID_AUTO, run, CTLTYPE_INT | CTLFLAG_RW, 0, sizeof(int), sysctl_kern_caml_run, "I", "activate embedded code");

static int
event_handler(struct module *module, int event, void *arg) {
	int e = 0;
	switch (event) {
	case MOD_LOAD:
		uprintf("[CAML] Kernel module is about to load.\n");
		break;
	case MOD_UNLOAD:
		uprintf("[CAML] Kernel module is about to unload.\n");
		break;
	default:
		e = EOPNOTSUPP;
		break;
	}
	return e;
}

static moduledata_t caml_conf = {
    "caml"
,   event_handler
,   NULL
};

DECLARE_MODULE(caml, caml_conf, SI_SUB_DRIVERS, SI_ORDER_MIDDLE);
